/*
 * Copyright 2008  Rivo Laks <rivolaks@hot.ee>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of
 * the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef MODELVIEWER_H
#define MODELVIEWER_H

#include <kgllib/glwidget.h>
#include <kgllib/trackball.h>
#include <kgllib/texture.h>
#include <kgllib/program.h>

using namespace KGLLib;

class AsteroidGen;
class Vertex;


class ModelViewer : public GLWidget
{
public:
    ModelViewer(QWidget* parent);

    void setGenerator(AsteroidGen* generator);

protected:
    virtual void mousePressEvent(QMouseEvent* e);
    virtual void mouseMoveEvent(QMouseEvent* e);

    virtual void initializeGL();
    virtual void render();
    void renderVertex(const Vertex& v);

private:
    AsteroidGen* mGenerator;
    TrackBall mTrackball;
    QPoint lastMousePos;

    Texture* mTexture;
    Program* mProgram;
};

#endif
