uniform sampler2D diffuseTexture;


vec3 calculateMaterial(vec3 L, vec3 Lcolor, vec3 N)
{
    vec3 texColor = texture2D(diffuseTexture, gl_TexCoord[0].xy).rgb;
    
    float NdotL = max(dot(N, L), 0.0);

    return Lcolor * texColor * NdotL;
}

vec3 calculateMaterialAmbient(vec3 Lcolor)
{
    vec3 texColor = texture2D(diffuseTexture, gl_TexCoord[0].xy).rgb;

    return Lcolor * texColor;
}
