// Vertex coordinates in eye space
varying vec4 vertexEye;
varying vec3 normal;


void calculateLightVertex();
void calculateMaterialVertex();


void main()
{
    vec4 positionWorld;
    positionWorld.x = dot(gl_MultiTexCoord1, gl_Vertex);
    positionWorld.y = dot(gl_MultiTexCoord2, gl_Vertex);
    positionWorld.z = dot(gl_MultiTexCoord3, gl_Vertex);
    positionWorld.w = 1.0;

    vertexEye = gl_ModelViewMatrix * positionWorld;
    gl_Position = gl_ProjectionMatrix * vertexEye;

    normal.x = dot(gl_MultiTexCoord1.xyz, gl_Normal);
    normal.y = dot(gl_MultiTexCoord2.xyz, gl_Normal);
    normal.z = dot(gl_MultiTexCoord3.xyz, gl_Normal);
    normal = (gl_ModelViewMatrix * vec4(normal, 0.0)).xyz;

    calculateLightVertex();
    calculateMaterialVertex();
}
