/*
 * Copyright 2008-2009  Rivo Laks <rivolaks@hot.ee>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of
 * the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef SHIP_H
#define SHIP_H

#include "gameobject.h"


/**
 * @author Rivo Laks <rivolaks@hot.ee>
 */
class Ship : public GameObject
{
public:
    Ship();
    ~Ship();

    virtual Type type() const  { return T_Ship; }

    virtual void advance(float elapsed);
    virtual void collision(const Vector3f& force);
    virtual void addRotation(const Vector3f& rot);
    void dodge(int x, int y);

    float acceleration;
    float thrust;
    Vector3f rotvelocity;

    // How many dodges can the player do
    float dodgesAvailable;
    // How long before the dodges will start to reload again
    float timeToDodgeReload;

    float lastshoottime;
    float health;
    bool lightOn;
};

#endif
