/***************************************************************************
 *   Copyright (C) 2009 by Alexander Smirnov                               *
 *   alexander.v.smirnov@gmail.com                                         *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program. If not, see <http://www.gnu.org/licenses/>.  *
 ***************************************************************************/

#include "backgammonview.h"
#include "backgammonscene.h"
#include "settings.h"

#include <QtGui/QLabel>
#include <QGraphicsScene>
#include <QResizeEvent>

#include <klocale.h>
#include <kdebug.h>

BackgammonView::BackgammonView( BackgammonScene* scene, QWidget *parent )
    : QGraphicsView(scene, parent), m_scene(scene)
{
    setCacheMode( QGraphicsView::CacheBackground );
    setHorizontalScrollBarPolicy(Qt::ScrollBarAlwaysOff);
    setVerticalScrollBarPolicy(Qt::ScrollBarAlwaysOff);
    setFrameStyle( QFrame::NoFrame );
    setOptimizationFlags( QGraphicsView::DontClipPainter |
            QGraphicsView::DontSavePainterState |
            QGraphicsView::DontAdjustForAntialiasing );
}

void BackgammonView::resizeEvent( QResizeEvent* ev )
{
    m_scene->resizeScene( ev->size().width(), ev->size().height() );
}
