/*
    This program is free software; you can redistribute it and/or
    modify it under the terms of the GNU General Public License
    as published by the Free Software Foundation; either version 2
    of the License, or (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 51 Franklin Street, Fifth Floor,
    Boston, MA  02110-1301, USA.

    ---
    Copyright (C) 2011, Dmitry Chernov diman4ik.chernov@gmail.com
 */

#ifndef _FibsWidget_h_
#define _FibsWidget_h_

#include <QDialog>

#include "ui_bgfibs.h"
#include "own_info.h"
#include "move.h"

class WhoInfoList;


class FibsWidget : public QDialog
{
    Q_OBJECT
public:
    explicit FibsWidget( QWidget* parent = 0 );
    ~FibsWidget();

public slots:
    void add( QString line );
    
    void info( QString line );
    void chat( QString line );
    void game( QString line );
    
    void newWhoInfo( WhoInfo info );
    
    void sendReady();
    
    void letsSay();
    void letsShout();
    void letsKibitz();
    void letsWhisper();

    
    void pipChecked( bool );
    //void autoboardChecked( bool );
    void autodoubleChecked( bool );
    void automoveChecked( bool );
    void awayChecked( bool );
    //void bellChecked( bool );
    void crawfordChecked( bool );
    void doubleChecked( bool );
    void greedyChecked( bool );
    void moreboardsChecked( bool );
    void movesChecked( bool );
    void notifyChecked( bool );
    void ratingsChecked( bool );
    void readyChecked( bool );
    void reportChecked( bool );
    void silentChecked( bool );
    
    //void setCheckedStates( int , bool );
    void setCheckedStates( const QMap<int, bool>& toggles  );
    
    void resumeInvite( QString name );
    void playInvite( QString name, int length );
    
    void opponentMoves( const QVector<Move>& moves );
    
    void roll( int, int );
    
    void yourTurn();
    
    void listItemClicked( const QModelIndex & index );
    void listItemMenu( const QPoint & );
    void fibsPlayerListMenu( QAction* );
    
    void logouts( const QString& name );
    
signals:
    void sendLine( QString str );
    
    //void login( const QString& name, const QString& password );
    void message( const QString& name,  const QString& text );
    void tell( const QString& name, const QString& text );
    void invite( const QString& name, int length );
    //void join( QString name );
    
    void roll();
    void doubleCube();
    
    void toggle( int , bool );
    
    void accept();
    void rejectDouble();
    
    void say( const QString& txt );
    void shout( const QString& txt );
    
    void kibitz( const QString& txt );
    void whisper( const QString& txt );
    
private:
    Ui::Dialog m_ui;    
    
    QString m_curLine;
    
    WhoInfoList* m_infoList;
};

#endif
