/*
    This program is free software; you can redistribute it and/or
    modify it under the terms of the GNU General Public License
    as published by the Free Software Foundation; either version 2
    of the License, or (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 51 Franklin Street, Fifth Floor,
    Boston, MA  02110-1301, USA.

    ---
    Copyright (C) 2011, Dmitry Chernov diman4ik.chernov@gmail.com
 */

#ifndef _WhoInfoList_h_
#define _WhoInfoList_h_

#include <QAbstractTableModel>
#include "own_info.h"


class WhoInfoList : public QAbstractTableModel
{
    Q_OBJECT
public:
    WhoInfoList( QObject* parent = 0 );
    ~WhoInfoList();

    int rowCount( const QModelIndex &parent ) const;
    int columnCount( const QModelIndex &parent ) const;
    
    QVariant data( const QModelIndex &index, int role ) const;
    QVariant headerData( int section, Qt::Orientation orientation, int role ) const;
    
    Qt::ItemFlags flags( const QModelIndex &index ) const;
    
    bool setData( const QModelIndex &index, const QVariant &value, int role=Qt::EditRole );
    bool insertRows( int position, int rows, const QModelIndex &index=QModelIndex() );
    bool removeRows( int position, int rows, const QModelIndex &index=QModelIndex() );
    QList<WhoInfo >& getList();
    
private:
    QList<WhoInfo> m_whoInfoList;
};

#endif
