/***************************************************************************
 *   Copyright (C) 2005 by Piotr Banasiak <piotrbanasiak@onet.pl>          *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to                             *
 *   the Free Software Foundation, 51 Franklin Street, Fifth Floor,        *
 *   Boston, MA 02110-1301, USA.                                           *
 ***************************************************************************/
#include "dxpmsg.h"
#include "dxpgamereq.h"

#include <QDataStream>

#include "dxpgamereq.h"
#include "dxpgameacc.h"

/* allowed types 
GAMEREQ R
GAMEACC A
MOVE    M
GAMEEND E
CHAT    C
BACKREQ B
BACKACC K
*/
DxpMsg::DxpMsg()
{
}


DxpMsg::~DxpMsg()
{
}



/*!
    \fn DxpMsg::readFrom()
 */
bool DxpMsg::readF( QDataStream& in )
{
   char c;
   int bytes=in.readRawData( &c, 1);
   if(bytes<=0)return 0;
   
   DxpMsg *pMsg=0;
   bool ok=false;
   switch ( c )
   {
      case 'R':
      {
         dxpGameReq req;
         ok=req.readFrom( in );
         
         if(ok)
         {
            dxpGameAcc acc;
            acc.writeTo( in );
         }
      }
      break;
      
      case 'A':
      {
         dxpGameAcc acc;
         acc.readFrom( in );
      }
      break;
      
      case 'M':
      {
         dxpMove move;
         ok=move.readFrom( in );
         if(ok)
         {
            dxpMove move2;
            move2.writeTo( in );
         }
         {
            dxpChat chat;
            chat.setText( "dupa blada");
            chat.writeTo( in);
         }
      }
      break;
      
      case 'E':
      {
         dxpGameEnd gameEnd;
         gameEnd.readFrom( in );
      }
      break;
      
      case 'C':
      {
        dxpChat chat;
        chat.readFrom( in );
      }
      break;
      /*
      case 'B':
      pMsg=new dxpBackReq();
      pMsg->readFrom( in );
      break;
      
      case 'K':
      pMsg=new dxpBackAcc();
      pMsg->readFrom( in );
      break;
      */
      default:
      qDebug( "unrecognized character Protocol Error type:%c",c );
   }
   return ok;
}


