/***************************************************************************
 *   Copyright (C) 2005 by Piotr Banasiak <piotrbanasiak@onet.pl>          *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to                             *
 *   the Free Software Foundation, 51 Franklin Street, Fifth Floor,        *
 *   Boston, MA 02110-1301, USA.                                           *
 ***************************************************************************/
#include "engineinfo.h"
#include <QtGlobal>

EngineInfo::EngineInfo()
{
   reset();
}

EngineInfo::~EngineInfo()
{
}

/*!
    \fn EngineInfo::print()
 */
void EngineInfo::print()
{
    qDebug( "maxDepth %d  nodes %d leafNodes %d nodesCut %d", maxDepth, nodes, leafNodes,nodesCut);
}


/*!
    \fn EngineInfo::reset()
 */
void EngineInfo::reset()
{
    
    maxDepth=0;
    Depth=0;
    nodes=0;
    score=0;
    
    leafNodes=0;
    nodesCut=0;
    unnecessarySacryfice=0;
    hashNodes=0;
    elapsed=0;
}

float EngineInfo::nodesPerSecond()const
{
   float miliseconds=elapsed;
   if( miliseconds<=1 )return 0;
   
   float fNodes=nodes;
   return ( fNodes/miliseconds );
}

void EngineInfo::start()
{
   reset();
   time.start();
}

void EngineInfo::stop(int score)
{
   this->elapsed=time.elapsed();
   this->score=score;
}


