/***************************************************************************
 *   Copyright (C) 2005 by Piotr Banasiak <piotrbanasiak@onet.pl>          *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to                             *
 *   the Free Software Foundation, 51 Franklin Street, Fifth Floor,        *
 *   Boston, MA 02110-1301, USA.                                           *
 ***************************************************************************/
#include "historyheuristic.h"

HH_item::HH_item()
{
  from=-1;
  to=-1;
  cnt=0;
}
HH_item::~HH_item()
{
}

HistoryHeuristic::HistoryHeuristic()
{
   clear();
}
//--------------------------------------------------------------------------------
HistoryHeuristic::~HistoryHeuristic()
{
}
//--------------------------------------------------------------------------------
void HistoryHeuristic::clear()
{
   HH.clear();
}
//--------------------------------------------------------------------------------
// minimum depth ==0.
// from and to are square numbers. captured pieces are ingored completely
void HistoryHeuristic::goodMove( int from, int to, int depth, int reqDepth )
{
   int s=HH.size();
   while( HH.size() < depth+1 )
   {
      QList<HH_item> H;
      HH.append( H );
   }
      
   s=HH.size();
   QList<HH_item> &H= HH[ depth ];
   
   HH_item hi;
   hi.from=from;
   hi.to=to;
   hi.cnt=0;
   
   int idx = H.indexOf( hi );
   if( idx<0 )
   {
      H.append( hi );
      idx=H.size()-1;
   }
   H[idx].cnt += (reqDepth*reqDepth);///@todo consider reqDepth at cnt H[idx].cnt += (1<<reqDepth)
}
//--------------------------------------------------------------------------------
void HistoryHeuristic::badMove(int from, int to, int depth, int reqDepth  )
{
   int s=HH.size();
   while( HH.size() < depth+1 )
   {
      QList<HH_item> H;
      HH.append( H );
   }
      
   s=HH.size();
   QList<HH_item> &H= HH[ depth ];
   
   HH_item hi;
   hi.from=from;
   hi.to=to;
   hi.cnt=0;
   
   int idx = H.indexOf( hi );
   if( idx<0 )
   {
      H.append( hi );
      idx=H.size()-1;
   }
   H[idx].cnt -= reqDepth;
}
//--------------------------------------------------------------------------------
int HistoryHeuristic::getCnt( int from, int to, int level )
{
   int s=HH.size();
   if(s<=level)return -1;
   
   QList<HH_item> &H= HH[ level ];
   
   HH_item hi;
   hi.from=from;
   hi.to=to;
   hi.cnt=0;
   
   int idx = H.indexOf( hi );
   if( idx<0) return -1;
   
   return H[idx].cnt;
}
