/***************************************************************************
 *   Copyright (C) 2005 by Piotr Banasiak <piotrbanasiak@onet.pl>          *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to                             *
 *   the Free Software Foundation, 51 Franklin Street, Fifth Floor,        *
 *   Boston, MA 02110-1301, USA.                                           *
 ***************************************************************************/
#ifndef HISTORYHEURISTIC_H
#define HISTORYHEURISTIC_H

/**
Killer move and history heuristic

	@author Piotr Banasiak <piotrbanasiak@onet.pl>
*/

#include <QList>

class HH_item
{
  public:
  HH_item();
  ~HH_item();
  
  bool operator==( const HH_item &hi)const
  {
     if(from!=hi.from)return false;
     if(to!=hi.to)return false;
     return true;
  }
  int from;
  int to;
  int cnt;
};

class HistoryHeuristic
{
public:
    HistoryHeuristic();

    ~HistoryHeuristic();
    void clear();
    
    public:
    void goodMove( int from, int to, int depth, int reqDepth );
    void badMove( int from, int to, int depth, int reqDepth );
    int getCnt( int from, int to, int level );
    
    private:
    QList< QList<HH_item> > HH;

};

#endif
