/***************************************************************************
 *   Copyright (C) 2005 by Piotr Banasiak <piotrbanasiak@onet.pl>          *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to                             *
 *   the Free Software Foundation, 51 Franklin Street, Fifth Floor,        *
 *   Boston, MA 02110-1301, USA.                                           *
 ***************************************************************************/
#include "movelistview.h"
#include "movelistmodel.h"

MoveListView::MoveListView(QWidget *parent):QTableView( parent )
{
   setAlternatingRowColors(true);
   setSelectionMode( QAbstractItemView::NoSelection );
   connect( this, SIGNAL(clicked(const QModelIndex &)), this, SLOT(onClicked(const QModelIndex &)) );
}


MoveListView::~MoveListView()
{
}


void MoveListView::dataChanged ( const QModelIndex & index1, const QModelIndex & index2)
{
   //int r=index1.row();
   //int c=index1.column();
   
   QTableView::dataChanged( index1, index2 );
   scrollTo( index2 );
}



/*!
    \fn MoveListView::onClicked(const QModelIndex & index)
 */
void MoveListView::onClicked(const QModelIndex & index)
{
    /// @todo implement me
    qDebug( "MoveListView::onClicked" );
    QAbstractItemModel * m=model();
    m->data( index, Qt::UserRole );
}

#include "movelistview.moc"
