/***************************************************************************
 *   Copyright (C) 2005 by Piotr Banasiak <piotrbanasiak@onet.pl>          *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to                             *
 *   the Free Software Foundation, 51 Franklin Street, Fifth Floor,        *
 *   Boston, MA 02110-1301, USA.                                           *
 ***************************************************************************/
#ifndef PIECEDELEGATE_H
#define PIECEDELEGATE_H

#include <QAbstractItemDelegate>

/**
Delegate from Model View design pattern

	@author Piotr Banasiak <piotrbanasiak@onet.pl>
*/

class QAbstractItemModel;
class QObject;
class QPainter;
class QPixmap;

class PieceDelegate : public QAbstractItemDelegate
{

public:
enum myRoles
{
   nextStepRole=Qt::UserRole,
   currentPieceRole,
   lastMoveRole,
   canMoveRole
};
    PieceDelegate(QObject *parent = 0);

    ~PieceDelegate();
    
    void paint(QPainter *painter, const QStyleOptionViewItem &option,
               const QModelIndex &index) const;

    QSize sizeHint(const QStyleOptionViewItem &option,
                   const QModelIndex &index ) const;
    private:
    QPixmap *lightSQ,*darkSQ,*markedSQ,*indicatedSQ,*moveable;
    QPixmap *blackM,*blackK;
    QPixmap *whiteM,*whiteK;
    bool editorEvent ( QEvent * event, QAbstractItemModel * model, const QStyleOptionViewItem & option, const QModelIndex & index );
};

#endif
