/*
 * Copyright 2008 Marijn Kruisselbrink <m.kruisselbrink@student.tue.nl>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of
 * the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
#ifndef MAIN_H
#define MAIN_H

#include <QGLWidget>

class MainWidget : public QGLWidget
{
    Q_OBJECT
public:
    MainWidget(QWidget* parent = 0);
protected:
    void initializeGL();
    void paintGL();
    void resizeGL(int width, int height);
    void keyPressEvent(QKeyEvent* event);
    void keyReleaseEvent(QKeyEvent* event);
    void mouseMoveEvent(QMouseEvent* event);

    void renderDrunkStuff();
    void drawFPS();
    void drawRoundText(int teamId);
    void drawHUDRect();

    void initTextDrawing();
    void deInitTextDrawing();
    void drawText(int x, int y, const QString& text);
protected slots:
    void idle();
private:
    QPoint lastPos;
};

#endif // MAIN_H
