/*
    ziprommetadata.h - ZIP File support.

    Copyright (c) 2005      by Michaël Larouche       <larouche@kde.org>

    *************************************************************************
    *                                                                       *
    * This program is free software; you can redistribute it and/or modify  *
    * it under the terms of the GNU General Public License as published by  *
    * the Free Software Foundation; either version 2 of the License, or     *
    * (at your option) any later version.                                   *
    *                                                                       *
    *************************************************************************
*/
#ifndef GAMEFUZIPROMMETADATA_H
#define GAMEFUZIPROMMETADATA_H

#include <rommetadata.h>

namespace Gamefu {

/**
 * Handle ZIP file. 
 * Check if the files in the ZIP files containts valid ROM file and extract metainformation from them.
 *
 * @author Michaël Larouche <larouche@kde.org>
 */
class ZipRomMetaData : public RomMetaData
{
public:
	ZipRomMetaData();
	virtual ~ZipRomMetaData();

	virtual RomMetaInformation extractMetaInformation(KFileItem* item);

private:
	bool isValidRomFile(const QString &mimeType);

private:
	class Private;
	Private *d;
};

}

#endif
