/*
    gbxrommetadata.h - Extract metadata(information) from GBX ROM file.

    Copyright (c) 2006      by Michaël Larouche       <larouche@kde.org>

    *************************************************************************
    *                                                                       *
    * This program is free software; you can redistribute it and/or modify  *
    * it under the terms of the GNU General Public License as published by  *
    * the Free Software Foundation; either version 2 of the License, or     *
    * (at your option) any later version.                                   *
    *                                                                       *
    *************************************************************************
*/
#ifndef GBXROMMETADATA_H
#define GBXROMMETADATA_H

#include <defaultrommetadata.h>

/**
 * Extract metadata(information) from GBX ROM file.
 * 
 * @author Michaël Larouche <larouche@kde.org>
*/
class GbxRomMetaData : public Gamefu::DefaultRomMetaData
{
public:
	GbxRomMetaData();
	~GbxRomMetaData();
	
	virtual Gamefu::RomMetaInformation extractMetaInformation(KFileItem* item);
	virtual Gamefu::RomMetaInformation extractMetaInformation(QIODevice* device);
};

#endif
