/***************************************************************************
 *   Copyright 2009 Stefan Majewsky <majewsky@gmx.net>
 *
 *   This program is free software; you can redistribute it and/or
 *   modify it under the terms of the GNU General Public
 *   License as published by the Free Software Foundation; either
 *   version 2 of the License, or (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
 ***************************************************************************/

#ifndef KOLF_BLENDER_TEXTUREPOOL_H
#define KOLF_BLENDER_TEXTUREPOOL_H

#include <QStandardItemModel>

namespace Kolf
{
	class BlenderTexturePool : public QStandardItemModel
	{
		Q_OBJECT
		Q_DISABLE_COPY(BlenderTexturePool)
		private:
			BlenderTexturePool();
		public:
			enum Roles {
				KeyRole = Qt::UserRole + 1,
				ImageRole,
				ThumbnailRole
			};

			static Kolf::BlenderTexturePool* instance();
			QModelIndex findKey(const QString& key) const;
	};
}

#endif // KOLF_BLENDER_TEXTUREPOOL_H
