/***************************************************************************
 *   Copyright 2009 Zeng Huan <zh.issac@gmail.com>
 *   Copyright 2009 Stefan Majewsky <majewsky@gmx.net>
 *
 *   This program is free software; you can redistribute it and/or
 *   modify it under the terms of the GNU General Public
 *   License as published by the Free Software Foundation; either
 *   version 2 of the License, or (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
 ***************************************************************************/

#ifndef KOLF_BLENDER_WIDGET_H
#define KOLF_BLENDER_WIDGET_H

#include "../engine/gameui-pagewidget.h"
class QLabel;

namespace Kolf
{
	class BlenderManager;
	class BlenderStacker;

	class BlenderWidget : public Kolf::GameUIPageWidget
	{
		Q_OBJECT
		public:
			BlenderWidget();
			virtual ~BlenderWidget();

			Kolf::BlenderManager* manager() const;
		public Q_SLOTS:
			void updateTexture();
		private:
			void setupUI();

			Kolf::BlenderManager* m_manager;
			QLabel* m_textureViewer;
			Kolf::BlenderStacker* m_stacker;
	};
}

#endif // KOLF_BLENDER_WIDGET_H
