/***************************************************************************
 *   Copyright 2009 Zeng Huan <zh.issac@gmail.com>
 *
 *   This program is free software; you can redistribute it and/or
 *   modify it under the terms of the GNU General Public
 *   License as published by the Free Software Foundation; either
 *   version 2 of the License, or (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
 ***************************************************************************/

#include "hmcreator-allselectbutton.h"

#include <KIcon>
#include <KLocalizedString>

Kolf::AllSelectButton::AllSelectButton(QWidget* parent)
	: ToolButton(parent)
{
	setIcon(KIcon(""));
	setText(i18n("Clear selection"));
	setToolTip(i18n("Clears any previous selection."));
	setObjectName("AllSelectButton");
}

Kolf::AllSelectButton::~AllSelectButton()
{
}

void Kolf::AllSelectButton::onSelected(DrawingBoard* board)
{
	QPainterPath path;
	path.addRect(0, 0, board->width() - 1, board->height() - 1);
	board->setSelection(path);
}
