/***************************************************************************
 *   Copyright 2009 Zeng Huan <zh.issac@gmail.com>
 *
 *   This program is free software; you can redistribute it and/or
 *   modify it under the terms of the GNU General Public
 *   License as published by the Free Software Foundation; either
 *   version 2 of the License, or (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
 ***************************************************************************/

#ifndef KOLF_HMCREATOR_ERASERBUTTON_H
#define KOLF_HMCREATOR_ERASERBUTTON_H
#include "hmcreator-toolbutton.h"

namespace Kolf
{
	class EraserButton : public ToolButton
	{
		Q_OBJECT
		public:
			explicit EraserButton(QWidget* parent = 0);
			~EraserButton();

		public Q_SLOTS:
			void setEraserWidth(int eraserWidth) {m_eraserWidth = eraserWidth;}

		protected:
			virtual void handleMousePressed(DrawingBoard* board, QMouseEvent* event);
			virtual void handleMouseMoved(DrawingBoard* board, QMouseEvent* event);
			virtual void handleMouseReleased(DrawingBoard* board, QMouseEvent* event);
		private:
			void erase(DrawingBoard* board, QMouseEvent* event);
			QPointF m_eraserLastPoint;
			int m_eraserWidth;
	}; 
}
#endif // KOLF_HMCREATOR_ERASERBUTTON_H
