/***************************************************************************
 *   Copyright 2009 Zeng Huan <zh.issac@gmail.com>
 *
 *   This program is free software; you can redistribute it and/or
 *   modify it under the terms of the GNU General Public
 *   License as published by the Free Software Foundation; either
 *   version 2 of the License, or (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
 ***************************************************************************/

#ifndef KOLF_HMCREATOR_FILLCONFWIDGET_H
#define KOLF_HMCREATOR_FILLCONFWIDGET_H
#include <QList>
#include <QWidget>

class QToolButton;

namespace Kolf
{
	class ToolButton;
	class ShadeConfWidget;

	class FillConfWidget : public QWidget
	{
		Q_OBJECT
		public:
			explicit FillConfWidget(ToolButton* button, QWidget* parent = 0);
	
		Q_SIGNALS:
			void stopsChanged(const QGradientStops& stops);
			void spreadChanged(const QGradient::Spread& stops);
			void typeChanged(const Qt::BrushStyle& style);
	
		private Q_SLOTS:
			void buttonChanged();
	
		private:
			void setupUI();
			void prepareButton(QToolButton* button);
			QGradientStops m_gradientStops;
			QGradient::Spread m_gradientSpread;
			Qt::BrushStyle m_gradientType;
			ToolButton* m_button;
			QToolButton* m_radialGradientButton;
			QToolButton* m_linearGradientButton;
			QToolButton* m_conicalGradientButton;
			ShadeConfWidget* m_shadeWidget;
			QList<QToolButton*> m_buttonList;
			QToolButton* m_previousButton;
	};
}
#endif // KOLF_HMCREATOR_FILLCONFWIDGET_H
