/***************************************************************************
 *   Copyright 2009 Zeng Huan <zh.issac@gmail.com>
 *
 *   This program is free software; you can redistribute it and/or
 *   modify it under the terms of the GNU General Public
 *   License as published by the Free Software Foundation; either
 *   version 2 of the License, or (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
 ***************************************************************************/

#ifndef KOLF_HMCREATOR_SHADECONFWIDGET_H
#define KOLF_HMCREATOR_SHADECONFWIDGET_H

#include <QWidget>
namespace Kolf
{
	class ToolButton;
	class HoverPoints;
	class ShadeConfWidget : public QWidget
	{
		Q_OBJECT
		public:
			explicit ShadeConfWidget(ToolButton* button, QWidget* parent = 0);
	   		QSize sizeHint() const { return QSize(150, 80); }
	
		protected:
			void paintEvent(QPaintEvent* event);
			void showEvent(QShowEvent* event);
	
		Q_SIGNALS:
			void stopsChanged(const QGradientStops& stops);
	
		private Q_SLOTS:
			void changePoints(const QPolygonF& points);
			void changeStops();
			void reset();
		private:
			void createShade();
			void reloadPoints();
			QGradientStops m_gradientStops;
			ToolButton* m_button;
			QPixmap m_shade;
			HoverPoints* m_hoverPoints;
	    		QPolygonF m_points;
	};
}
#endif // KOLF_HMCREATOR_SHADECONFWIDGET_H
