/***************************************************************************
 *   Copyright 2009 Zeng Huan <zh.issac@gmail.com>
 *
 *   This program is free software; you can redistribute it and/or
 *   modify it under the terms of the GNU General Public
 *   License as published by the Free Software Foundation; either
 *   version 2 of the License, or (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
 ***************************************************************************/

#ifndef KOLF_HMCREATOR_TOOLBOX_H
#define KOLF_HMCREATOR_TOOLBOX_H
#include "../engine/gameui-dockwidget.h"

namespace Kolf
{
	class DrawingBoard;
	class ToolBoxConfWidget;
	class ToolButton;
	class ToolBox : public GameUIDockWidget 
	{
		Q_OBJECT
		public:
			ToolBox(DrawingBoard* board);
			~ToolBox();
			ToolButton* button(const QString& buttonName);
	
		private Q_SLOTS:
			void buttonChanged();

		Q_SIGNALS:
			void setCurrentButton(ToolButton* button);

		private:
			void setupUI();
			QList<ToolButton*> m_buttonList;
			ToolBoxConfWidget* m_confWidget;
			DrawingBoard* m_drawingBoard;
	};
}
#endif // KOLF_HMCREATOR_TOOLBOX_H
