/***************************************************************************
 *   Copyright 2009 Zeng Huan <zh.issac@gmail.com>
 *
 *   This program is free software; you can redistribute it and/or
 *   modify it under the terms of the GNU General Public
 *   License as published by the Free Software Foundation; either
 *   version 2 of the License, or (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
 ***************************************************************************/

#ifndef KOLF_HMCREATOR_TOOLBUTTON_H
#define KOLF_HMCREATOR_TOOLBUTTON_H
#include "hmcreator-drawingboard.h"
#include <QMouseEvent>
#include <QToolButton>

namespace Kolf
{
	class DrawingBoard;
	/**
	 * This class is the base class for implementing a specific toolbutton(e.g. penButton, eraserButton) which can take action on Kolf::DrawingBoard.
	 *
	 */
	class ToolButton : public QToolButton
	{
		public:
			explicit ToolButton(QWidget* parent = 0);
			virtual ~ToolButton();
			///Returns the appropriate size for the button.
			virtual QSize sizeHint() const;
			///Takes some action on the given drawing board.
			virtual void work(DrawingBoard* board, QMouseEvent* event);
			///Takes reaction to the selected event. e.g. do some preparing work.
			virtual void onSelected(DrawingBoard* board);

		protected:
			virtual void handleMousePressed(DrawingBoard* board, QMouseEvent* event);
			virtual void handleMouseMoved(DrawingBoard* board, QMouseEvent* event);
			virtual void handleMouseReleased(DrawingBoard* board, QMouseEvent* event);

	};

}

#endif // KOLF_HMCREATOR_TOOLBUTTON_H
