/***************************************************************************
 *   Copyright 2008-2009 Stefan Majewsky <majewsky@gmx.net>
 *
 *   This program is free software; you can redistribute it and/or
 *   modify it under the terms of the GNU General Public
 *   License as published by the Free Software Foundation; either
 *   version 2 of the License, or (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
 ***************************************************************************/

#ifndef KOLF_OBJECT_HOLE_H
#define KOLF_OBJECT_HOLE_H

#include "object.h"

class QGraphicsEllipseItem;

namespace Kolf
{
	//This object's reference point is at its center (in X/Y direction) and upper bound (in Z direction).
	class HoleObject : public Kolf::Object
	{
		Q_OBJECT
		public:
			HoleObject(dWorldID worldID, dSpaceID spaceID);
			~HoleObject();

			virtual bool isRotateable() const { return false; }

			virtual Kolf::Object::SimulationFlags simulationFlags() const;
			virtual void doCustomInteraction(Kolf::Object* object);

			static const int HoleRadius;
		protected:
			virtual Kolf::Overlay* createOverlay();
		private:
			QGraphicsEllipseItem* m_holeItem;
	};
}

#endif // KOLF_OBJECT_HOLE_H
