/***************************************************************************
 *   Copyright 2009 Zeng Huan <zh.issac@gmail.com>
 *
 *   This program is free software; you can redistribute it and/or
 *   modify it under the terms of the GNU General Public
 *   License as published by the Free Software Foundation; either
 *   version 2 of the License, or (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
 ***************************************************************************/

#include "object-puddle.h"
#include "objectregistry.h"
#include "overlay-empty.h"
#include <KStandardDirs>

REGISTER_KOLF_OBJECT(Kolf::PuddleObject, ki18n("Puddle"), KIcon())

namespace Kolf
{
	const QString TextureFileNamePattern("kolf-ng/courses/%1");
}

Kolf::PuddleObject::PuddleObject(dWorldID worldID, dSpaceID spaceID)
	: Kolf::Object(worldID, spaceID)
{

}

Kolf::PuddleObject::~PuddleObject()
{

}

void Kolf::PuddleObject::createSpatialGeometry()
{

}

float* Kolf::PuddleObject::getNormalGeometry()
{
	return 0;
}

float* Kolf::PuddleObject::getVertexGeometry()
{
	return 0;
}

void Kolf::PuddleObject::setPathToTexture(const QString& path)
{	
	const QString fileName = KStandardDirs::locate("data", Kolf::TextureFileNamePattern.arg(path));
	if(fileName.isEmpty())
		return;
	m_pathToTexture = fileName;
}

Kolf::Overlay* Kolf::PuddleObject::createOverlay()
{
	return new Kolf::EmptyOverlay(this);
}

#include "object-puddle.moc"
