/***************************************************************************
 *   Copyright 2008-2009 Stefan Majewsky <majewsky@gmx.net>
 *
 *   This program is free software; you can redistribute it and/or
 *   modify it under the terms of the GNU General Public
 *   License as published by the Free Software Foundation; either
 *   version 2 of the License, or (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
 ***************************************************************************/

#ifndef KOLF_OBJECT_RECTBLOCK_H
#define KOLF_OBJECT_RECTBLOCK_H

#include "math-sizef.h"
#include "object.h"

class QGraphicsRectItem;

namespace Kolf
{
	class CuboidGeometry;

	///Note: The reference point for this object is its center.
	class RectBlockObject : public Kolf::Object
	{
		Q_OBJECT
		Q_PROPERTY(Kolf::SizeF Size READ size WRITE setSize)
		public:
			RectBlockObject(dWorldID worldID, dSpaceID spaceID);
			~RectBlockObject();

			Kolf::SizeF size() const;
			void setSize(const Kolf::SizeF& size);

			virtual void createSpatialGeometry();
			virtual float* getNormalGeometry();
			virtual float* getVertexGeometry();
		protected:
			virtual void objectEvent(int type, const QVariant& data);
			virtual Overlay* createOverlay();
		private:
			Kolf::CuboidGeometry* m_geometry;
			QGraphicsRectItem* m_item;

			float *m_vertexArray, *m_normalArray;
	};
}

#endif // KOLF_OBJECT_RECTBLOCK_H
