/***************************************************************************
 *   Copyright 2009 Stefan Majewsky <majewsky@gmx.net>
 *
 *   This program is free software; you can redistribute it and/or
 *   modify it under the terms of the GNU General Public
 *   License as published by the Free Software Foundation; either
 *   version 2 of the License, or (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
 ***************************************************************************/

#ifndef KOLF_OVERLAY_BLACKHOLE_H
#define KOLF_OVERLAY_BLACKHOLE_H

#include "overlay.h"

namespace Kolf
{
	class PointHandle;

	//This overlay requires the following object properties:
	// Kolf::PointF ExitOffset
	// Kolf::PointF ExitVelocity
	class BlackHoleOverlay : public Kolf::Overlay
	{
		Q_OBJECT
		public:
			BlackHoleOverlay(Kolf::Object* object);
			virtual void update();
		private Q_SLOTS:
			//interface to handles
			void moveHandle(const QPointF& handleScenePos);
		private:
			QGraphicsLineItem* m_exitLine;
			QGraphicsLineItem* m_exitVelocityLine;
			Kolf::PointHandle* m_exitHandle;
			Kolf::PointHandle* m_exitVelocityHandle;
	};
}

#endif // KOLF_OVERLAY_BLACKHOLE_H
