/***************************************************************************
 *   Copyright 2009 Stefan Majewsky <majewsky@gmx.net>
 *
 *   This program is free software; you can redistribute it and/or
 *   modify it under the terms of the GNU General Public
 *   License as published by the Free Software Foundation; either
 *   version 2 of the License, or (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
 ***************************************************************************/

#ifndef KOLF_COMPONENT_BASICVIEWS_H
#define KOLF_COMPONENT_BASICVIEWS_H

#include "gameui-pagewidget.h"

namespace Kolf
{
	class View2D;
	class View3D;

	class View2DComponent : public Kolf::GameUIPageWidget
	{
		public:
			View2DComponent();
		protected:
			virtual void currentSceneChanged(Kolf::Scene* oldScene, Kolf::Scene* newScene);
		private:
			Kolf::View2D* m_view;
	};

	class View3DComponent : public Kolf::GameUIPageWidget
	{
		public:
			View3DComponent();
		protected:
			virtual void currentSceneChanged(Kolf::Scene* oldScene, Kolf::Scene* newScene);
		private:
			Kolf::View3D* m_view;
	};
}

#endif // KOLF_COMPONENT_BASICVIEWS_H
