/***************************************************************************
 *   Copyright 2008-2009 Stefan Majewsky <majewsky@gmx.net>
 *
 *   This program is free software; you can redistribute it and/or
 *   modify it under the terms of the GNU General Public
 *   License as published by the Free Software Foundation; either
 *   version 2 of the License, or (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
 ***************************************************************************/

#include "interface/mainwindow.h"

#include <KAboutData>
#include <KApplication>
#include <KCmdLineArgs>
#include <KGlobal>
#include <KLocale>
#include <ode/ode.h>

int main(int argc, char** argv)
{
	//note: increase version to 2.0 and rename to "kolf" once it it stable
	KAboutData about("kolf-ng", "kolf", ki18nc("The application's name", "Kolf"), "0.0.1", ki18n("KDE Minigolf Game"), KAboutData::License_GPL, ki18n("Copyright 2008-2009, the Kolf team"));
	about.addAuthor(ki18n("Stefan Majewsky"), ki18n("Lead developer"), "majewsky@gmx.net", "http://majewsky.wordpress.com");
	about.addAuthor(ki18n("Casper van Donderen"), ki18n("3D guy"), "casper.vandonderen@gmail.com", "http://aloogobi.nl");
	//TODO: credit all authors and contributors of Kolf 1.x

	dInitODE();

	KCmdLineArgs::init(argc, argv, &about);
	KApplication app;
	KGlobal::locale()->insertCatalog("libkdegames");

	new Kolf::MainWindow;
	return app.exec();
}
