/***************************************************************************
 *   Copyright 2008, 2009, 2010 Stefan Majewsky <majewsky@gmx.net>
 *
 *   This program is free software; you can redistribute it and/or
 *   modify it under the terms of the GNU General Public
 *   License as published by the Free Software Foundation; either
 *   version 2 of the License, or (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
 ***************************************************************************/

#ifndef KOLF_OBJECT_HOLE_H
#define KOLF_OBJECT_HOLE_H

#include "object.h"

namespace Kolf
{
	class CircleShape;

	//This object's reference point is its center.
	class HoleObject : public Kolf::Object
	{
		Q_OBJECT
		public:
			HoleObject(b2World* world);

			///Ratio of hole radius to ball radius.
			static const qreal SizeFactor;
			///Ratio of radius of capture area to ball radius.
			static const qreal CaptureSizeFactor;
		protected:
			Kolf::Overlay* createOverlay();
		private:
			Kolf::CircleShape* m_shape;
			Kolf::CircleShape* m_captureShape;
			QGraphicsEllipseItem* m_item;
	};
}

#endif // KOLF_OBJECT_HOLE_H
