/***************************************************************************
 *   Copyright 2008, 2009, 2010 Stefan Majewsky <majewsky@gmx.net>
 *
 *   This program is free software; you can redistribute it and/or
 *   modify it under the terms of the GNU General Public
 *   License as published by the Free Software Foundation; either
 *   version 2 of the License, or (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
 ***************************************************************************/

#ifndef KOLF_PUTTER_SIMPLE_H
#define KOLF_PUTTER_SIMPLE_H

#include "putter.h"

namespace Kolf
{
	class SimplePutter : public Kolf::Putter
	{
		public:
			SimplePutter(QGraphicsScene* scene);
		protected:
			virtual void handleMousePress(Qt::MouseButton button, const QPointF& cursorPosition);
			virtual void update(QWidget* activeView, const QPointF& cursorPosition);
			void updateAppearance();
		private:
			QGraphicsLineItem* m_lineItem;
			int m_direction; ///< 0 means that putter points in direction of mouse. Each +1 adds a difference of 90° (clockwise) between ball-cursor vector and velocity vector.
			//cache for update data
			QWidget* m_activeView;
			QPointF m_cursorPosition;
	};
}

#endif // KOLF_PUTTER_SIMPLE_H
