/***************************************************************************
 *   Copyright 2009, 2010 Stefan Majewsky <majewsky@gmx.net>
 *
 *   This program is free software; you can redistribute it and/or
 *   modify it under the terms of the GNU General Public
 *   License as published by the Free Software Foundation; either
 *   version 2 of the License, or (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
 ***************************************************************************/

#ifndef KOLF_GAME_EDITOR_H
#define KOLF_GAME_EDITOR_H

#include "game.h"

class QDockWidget;
class QToolButton;
class QVBoxLayout;
#include <QWidget>

namespace Kolf
{
	class EditorGame;

	class EditorToolbox : public QWidget
	{
		public:
			EditorToolbox(Kolf::EditorGame* game);
			void bootHole(Kolf::Hole* hole);
			void shutdownHole(Kolf::Hole* hole);
		private:
			Kolf::EditorGame* m_game;
			QVBoxLayout* m_buttonLayout;
			QList<QToolButton*> m_buttons;
	};

	class EditorGame : public Kolf::Game
	{
		Q_OBJECT
		public:
			EditorGame(Kolf::Course* course, Kolf::Interface* interface);
			virtual ~EditorGame();
		public Q_SLOTS:
			void cleanChanged();
			void saveRequest();
		protected:
			virtual void bootHole(Kolf::Hole* hole);
			virtual void shutdownHole(Kolf::Hole* hole);
		private:
			QDockWidget* m_toolboxDock;
			Kolf::EditorToolbox* m_toolbox;
	};
}

#endif // KOLF_GAME_EDITOR_H
