/***************************************************************************
 *   Copyright (C) 2005 by Albert Astals Cid <tsdgeos@terra.es>            *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 ***************************************************************************/

#include "gamelistwidget.h"
#include "client.h"

gameListWidget::gameListWidget(QWidget *parent, client *c) : QFrame(parent)
{
	setupUi(this);
	gamesView->setModel(c);
	joinGameButton->setEnabled(false);
	connect(createGameButton, SIGNAL(clicked()), this, SIGNAL(createServerGame()));
	connect(joinGameButton, SIGNAL(clicked()), this, SIGNAL(joinServerGame()));
	connect(gamesView->selectionModel(), SIGNAL( currentChanged ( const QModelIndex &, const QModelIndex &)), this, SLOT(enableJoin()));
	setFrameStyle(Box);
	setFrameShadow(Plain);
	setLineWidth(3);
	show();
}

int gameListWidget::selectedGameRow() const
{
	return gamesView->selectionModel()->currentIndex().row();
}

void gameListWidget::enableJoin()
{
	joinGameButton->setEnabled(true);
}

#include "gamelistwidget.moc"
