/***************************************************************************
 *   Copyright (C) 2005 by Albert Astals Cid <tsdgeos@terra.es>            *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 ***************************************************************************/

#include "ignoredialog.h"

#include <QTreeWidgetItem>

ignoreDialog::ignoreDialog(QWidget *parent) : QDialog(parent)
{
	setupUi(this);
	QStringList headers;
	headers << i18n("Name");
	treeWidget->setHeaderLabels(headers);
}

void ignoreDialog::setNicks(const QStringList &nicks, const QStringList &ignoredNicks)
{
	QTreeWidgetItem *qtwi;
	bool checked;
	
	foreach(const QString &nick, nicks)
	{
		qtwi = new QTreeWidgetItem(treeWidget);
		checked = ignoredNicks.contains(nick);
		qtwi->setCheckState(0, checked ? Qt::Checked : Qt::Unchecked);
		qtwi->setText(0, nick);
	}
}

QStringList ignoreDialog::ignoredNicks() const
{
	QTreeWidgetItem *qtwi;
	QStringList res;

	for (int i = 0; i < treeWidget->topLevelItemCount(); i++)
	{
		qtwi = treeWidget->topLevelItem(i);
		if (qtwi->checkState(0) == Qt::Checked) res << qtwi->text(0);
	}
	return res;
}
