/***************************************************************************
 *   Copyright (C) 2006 by Pino Toscano <toscano.pino@tiscali.it>          *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 ***************************************************************************/

#ifndef KOMBINATIONSERVER_H
#define KOMBINATIONSERVER_H

#include <kxmlguiwindow.h>

class QTableView;
class chatWidget;
class eventsLogWidget;
class server;

class KombinationServer : public KXmlGuiWindow
{
Q_OBJECT
	public:
		KombinationServer();
		~KombinationServer();
	
	private slots:
		void startServer();

		void serverStarted();
		void disableServer();
		void serverError(const QString &text);

	private:
		chatWidget *m_chatWidget;
		server *m_server;
		QTableView *m_gamesView;
		eventsLogWidget *m_eventsLog;

		QAction *m_actStartServer;
		QAction *m_actStopServer;

		int m_port;
		QString m_nick;
		bool m_ready;
};

#endif
