/***************************************************************************
 *   Copyright (C) 2005 by Albert Astals Cid <tsdgeos@terra.es>            *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 ***************************************************************************/

#ifndef MULTIWIDGET_H
#define MULTIWIDGET_H

#include "ui_multiwidgetbase.h"

#include <QWidget>

class confirmWidget;

class multiWidget : public QWidget, private Ui_multiWidgetBase
{
Q_OBJECT
	public:
		explicit multiWidget(QWidget *parent);

		void setIAm(const QString &nick);
		void setMyselfReady(bool ready);

		QString currentPlayerNick() const;

		enum getPlayersNicksOption { GiveMyOwnNick, DoNotGiveMyOwnNick };
		QStringList getPlayersNicks( getPlayersNicksOption o );

		void addScoreCurrentPlayer(const QStringList &wordList, int score);
	
	signals:
		void confirmAccepted();
		void confirmRejected();

	public slots:
		void addPlayer(const QString &nick, int which);
		void changeStatus(const QString &nick, int which);
		void startGame();
		void nextPlayer(const QString &nick, bool isItMe);
		void showAndStartTimeout();
		void removePlayer(const QString &nick);
		void serverDown();
		void clearPlayerList();

	private slots:
		void restoreList();

	private:
		confirmWidget *m_confirmWidget;
		QString m_nick;
		bool m_ready;

		QTreeWidgetItem *m_currentPlayer;
};

#endif
