/***************************************************************************
 *   Copyright (C) 2005 by Albert Astals Cid <tsdgeos@terra.es>            *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 ***************************************************************************/

#include <QtTest/QtTest>

#include "../replacementshandler.h"
#include "replacementshandlertest.h"

void testReplacementsHandler::testReplacements()
{
	replacementsHandler rh;
	rh.addReplacement("a", "J");
	rh.addReplacement("a", "K");
	rh.addReplacement("ss", "W");
	rh.addReplacement("e", "ss");

	QStringList possibleWords = rh.possibleWords("aass");
	QStringList realPossibleWords;
	realPossibleWords << "aass" << "Jass" << "JJss" << "JJW" << "JaW" << "JKss" << "JKW" << "Kass" << "KJss" << "KJW" << "KKss" << "KKW" << "KaW" << "aJss" << "aJW" << "aKss" << "aKW" << "aaW";
	
	foreach (QString realPossibleWord, realPossibleWords)
	{
		int index = possibleWords.indexOf(realPossibleWord);
		QVERIFY( index != -1 );
		possibleWords.removeAt(index);
	}
	
	QVERIFY( possibleWords.isEmpty() );
}

QTEST_MAIN(testReplacementsHandler)

#include "replacementshandlertest.moc"

