/***************************************************************************
 *   Copyright (C) 2005 by Albert Astals Cid <tsdgeos@terra.es>            *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 ***************************************************************************/

#ifndef TILEBOX_H 
#define TILEBOX_H 
 
#include <QList>

#include "tile.h"

class tileBox
{
	public:
		tileBox();

		void newGame(const QList<tile> availableTiles);

		QList<tile*> getTiles(int num);
		void addTiles(const QList<tile*> &tiles);
		bool isEmpty();

		/*!
		 * Removes specific tile from the box. Useful for keeping tracks of what tiles are on board (mainly for AI).
		 */
		void removeTile(const tile* const tile);

		/*!
		 * Removes specific tiles from the box. Useful for keeping tracks of what tiles are on board (mainly for AI).
		 */
		void removeTiles(const QList<tile*> &tiles);

	private:
		void shuffle();
		tile *getTile();

		QList<tile> m_availableTiles;
};

#endif
