
#ifndef SELECTBOARD_H
#define SELECTBOARD_H

#include "xmlpicross.h"
#include <kdialog.h>

#include "ui_selectlevelui.h"

class Board;
class Levels;
class QTreeWidgetItem;

class SelectBoard : public KDialog
{
    Q_OBJECT
public:
    SelectBoard(const QList<BoardSetXml> &sets, QWidget *parent);

    BoardXml selectedBoard() const;

protected slots:
    void boardActivated(QTreeWidgetItem *item, int column);

protected:
    void fillTreeView();
    void findBoardFromItem(const QTreeWidgetItem *item) const;

private:
    Ui::LevelSelectUi *m_ui;
    QList<BoardSetXml> m_sets;

    mutable BoardSetXml m_currentSet;
    mutable BoardXml m_currentBoard;
};

#endif
