/**************************************************************************
*   Copyright (C) 2005 by Lukas Tinkl                                     *
*   lukas@kde.org                                                         *
*                                                                         *
*   This program is free software; you can redistribute it and/or modify  *
*   it under the terms of the GNU General Public License as published by  *
*   the Free Software Foundation; either version 2 of the License, or     *
*   (at your option) any later version.                                   *
*                                                                         *
*   This program is distributed in the hope that it will be useful,       *
*   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
*   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
*   GNU General Public License for more details.                          *
*                                                                         *
*   You should have received a copy of the GNU General Public License     *
*   along with this program; if not, write to the                         *
*   Free Software Foundation, Inc.,                                       *
*   51 Franklin Steet, Fifth Floor, Boston, MA 02110-1301, USA.             *
***************************************************************************/

#ifndef _PROPDIALOG_H_
#define _PROPDIALOG_H_

#include "propWidget.h"
#include "server.h"
#include "gameManager.h"

#include <kdialogbase.h>
#include <kreverseresolver.h>

#include <config.h>
#ifdef HAVE_LIBGEOIP
#include <GeoIP.h>
#endif

using namespace KNetwork;

/**
 * A dialog that displays further information about a server
 *
 * @brief Server properties dialog
 */
class PropDialog: public KDialogBase
{
    Q_OBJECT
public:
    /**
     * CTOR
     */
    PropDialog( GameManager * manager, Server * server,
#ifdef HAVE_LIBGEOIP
                GeoIP * gi,
#endif
                QWidget *parent = 0, const char *name = 0, bool modal = true );
    ~PropDialog();

private slots:
    /**
     * Updates the "hostname" label with resolved name
     */
    void resolveHostname( const KReverseResolver & obj );

private:
    PropWidget * m_w;
    KNetwork::KReverseResolver * m_resolver;
};

#endif
