/*
Copyright (c) 2006, 2007, Nicolas Roffet, <nicolas-kde@roffet.com>

This program is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation; either version 2 of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more details.

You should have received a copy of the GNU Library General Public License along with this program; if not, write to the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA
*/

#ifndef KSIMILIMAINWINDOW_H
#define KSIMILIMAINWINDOW_H



class QAction;
class KToggleAction;
#include <kxmlguiwindow.h>


class KSimiliMainWindowCentralWidget;



/**
 * @brief This is the main Window of the application.
 */
class KSimiliMainWindow : public KXmlGuiWindow
{
	Q_OBJECT

	public:
		static int const SIZE_BOARD = 12;
		static int const TIME_TO_PLAY = 240;


		KSimiliMainWindow(QWidget *parent = 0);


	public slots:
		void gameOver(const int speed);


	private slots:
		void newGame();
		void pause(bool pause);
		void togglePause();
		void showHighscores();
		void hint();
		void demo();
		void solve();


	private:
		KSimiliMainWindowCentralWidget *m_centralWidget;
	
		QAction *m_actionGameNew;
		QAction *m_actionHighscores;
		QAction *m_actionQuit;
		QAction *m_actionHint;
		QAction *m_actionSolve;
		KToggleAction *m_actionDemo;
		KToggleAction *m_actionDisplayNumberOfCombinations;
		KToggleAction *m_actionPause;
};

#endif //KSIMILIMAINWINDOW_H
