/*
Copyright (c) 2006, 2007, Nicolas Roffet, <nicolas-kde@roffet.com>

This program is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation; either version 2 of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more details.

You should have received a copy of the GNU Library General Public License along with this program; if not, write to the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA
*/

#ifndef KSIMILIMAINWINDOWCENTRALWIDGET_H
#define KSIMILIMAINWINDOWCENTRALWIDGET_H



#include <QFrame>
class QTimer;
class QVBoxLayout;
class QWidget;


class KSimiliBoard;
class KSimiliStatsWidget;
class KSimiliLastCombinationWidget;
class KSimiliMainWindow;



/**
 * @brief Central Widget of the main window.
 *
 * The main widget is in fact made of the "stats widgets" and the board game.
 */
class KSimiliMainWindowCentralWidget : public QFrame
{
	Q_OBJECT

	public:
		explicit KSimiliMainWindowCentralWidget(KSimiliMainWindow *parent);


	public slots:
		void newGame(const int sizeBoard, const int timeToPlay);
		void gameOver();
		void timeSlotOut();
		void pauseGame(bool pause);
		void activateDisplayPossibleCombinations(bool activation);
		void solve();
		void hint();


	private:
		KSimiliBoard *m_board;
		KSimiliStatsWidget *m_statsWidget;
		KSimiliLastCombinationWidget *m_lastCombinationWidget;
		QTimer *m_timer;

		int m_timeLeft;
		KSimiliMainWindow *m_mainWindow;
};

#endif //KSIMILIMAINWINDOWCENTRALWIDGET_H
