/*
Copyright (c) 2006, 2007, Nicolas Roffet, <nicolas-kde@roffet.com>

This program is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation; either version 2 of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more details.

You should have received a copy of the GNU Library General Public License along with this program; if not, write to the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA
*/

#include "ksimilistatswidget.h"



#include <QLabel>
#include <QLCDNumber>
#include <QProgressBar>
#include <QWidget>


#include <klocale.h>
#include <KMessageBox>


//TODO: i18n of the labels in the ui file.
#include "ui_ksimilistatswidget.h"


KSimiliStatsWidget::KSimiliStatsWidget(QWidget *parent) : QWidget(parent)
{
	setupUi(this);
}


int KSimiliStatsWidget::getCombinationsPerHour()
{
	return (int) (m_lcdCombinationsPerHour->value());
}



//
// Slots
//

void KSimiliStatsWidget::newGame(const int timeToPlay)
{
	m_lcdFound->display(0);
	m_lcdErrors->display(0);
	m_lcdCombinationsPerHour->display(0);
	m_progressBarTimeLeft->setMaximum(timeToPlay);
	m_progressBarTimeLeft->setValue(timeToPlay);
}


void KSimiliStatsWidget::gameOver()
{
	KMessageBox::information(this, i18n("Game over!"));
}


void KSimiliStatsWidget::newCombinationFound()
{
	m_lcdFound->display(m_lcdFound->value()+1);
}


void KSimiliStatsWidget::newErrorFound()
{
	m_lcdErrors->display(m_lcdErrors->value()+1);
}


void KSimiliStatsWidget::timeLeftChanged(const int timeLeft)
{
	m_progressBarTimeLeft->setValue(timeLeft);

	int speed = 0;
	int time = m_progressBarTimeLeft->maximum()-timeLeft;
	if (time>0)
		speed = (int) (3600 * m_lcdFound->value() / time);
	m_lcdCombinationsPerHour->display(speed);
}


void KSimiliStatsWidget::displayPossibleCombinations(int ksimilis)
{
	m_lcdTotal->display(ksimilis);
}


void KSimiliStatsWidget::activateDisplayPossibleCombinations(bool activation)
{
	m_lcdTotal->setVisible(activation);
	m_labelTotalBoard->setVisible(activation);
}

#include "ksimilistatswidget.moc"
