/*
    This file is part of KSpiral.
    Copyright 2009 Felix Lemke <hobbyblobby@arcor.de>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License along
    with this program; if not, write to the Free Software Foundation, Inc.,
    51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
*/

#ifndef KSPIRAL_CANNON_H
#define KSPIRAL_CANNON_H

#include <KGameRenderedObjectItem>
#include <QColor>
class KGameRenderer;
class QTimer;

namespace KSpiral {
	class Ball;
	class Cannon : public KGameRenderedObjectItem {
		Q_OBJECT
		public:
			Cannon(KGameRenderer* renderer, const QString& itemName, int cannonballVelocity);
			~Cannon();

			void setAngle(const qreal& newAngle); //the angle should be given as radiant
			KSpiral::Ball* shoot();

			void setBallList(const QStringList& list) {m_balls = list;}
			QString randomBalltype() const {return m_balls.value(qrand() % m_balls.size());}
			void setTop(KGameRenderedObjectItem* item) {m_top = item;}

		public Q_SLOTS:
			void loadCannon();

		private:
// 			KGameRenderer* m_renderer;
			KGameRenderedObjectItem* m_top;
			qreal m_angle;
			int m_ballVelocity;
			QPointF m_cannonCenter;
			KSpiral::Ball* m_ballToShoot;
			QStringList m_balls;
	};
}

#endif //KSPIRAL_CANNON_H
