/*
    This file is part of KSpiral.
    Copyright 2009 Felix Lemke <hobbyblobby@arcor.de>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License along
    with this program; if not, write to the Free Software Foundation, Inc.,
    51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
*/

#include <ctime>
#include <kapplication.h>
#include <kaboutdata.h>
#include <KGlobal>
#include <kcmdlineargs.h>
#include <KDE/KLocale>
#include "gameWindow.h"

static const char description[] =
    I18N_NOOP("A spiral puzzle game");

static const char version[] = "0.1";

int main(int argc, char **argv)
{
	KAboutData about("kspiral", 0, ki18n("KSpiral"), version, ki18n(description), KAboutData::License_GPL, ki18n("(C) 2009 Felix Lemke"), KLocalizedString(), 0, "hobbyblobby@arcor.de");
	about.addAuthor(ki18n("Felix Lemke"), KLocalizedString(), "hobbyblobby@arcor.de");
	KCmdLineArgs::init(argc, argv, &about);

#ifdef Q_WS_X11
	QApplication::setGraphicsSystem("raster");
#endif
	KApplication app;
	KGlobal::locale()->insertCatalog("libkdegames");
	qsrand(time(0));

	KSpiral::GameWindow* game = new KSpiral::GameWindow;
	game->show();

	return app.exec();
}
