#include "ktankengine.h"
#include "kglengine/kglphysicsimpl2.h"
#include <KDebug>
#include <KAction>

KTankEngine::KTankEngine(QWidget * parent)
    :KGLEngine2d( parent ) 
{	



   m_collection=new KActionCollection(this);
   m_playerTank = new KTankItem("sprites/");

   m_playerTank->scale(0.5);
   addItem(m_playerTank);
   


   m_listBullet = new KGLItemGroup;
   m_listWall   = new KGLItemGroup;
  // loadMap();


KGLSpriteItem * wall = new KGLSpriteItem("sprites/bloc.png");
wall->setRect(QRectF(0,0,2,0.1));
wall->translate(-1,-0.8);
m_listWall->insert(wall);
addItem(wall);

KGLSpriteItem * wall2 = new KGLSpriteItem("sprites/bloc.png");
wall2->setRect(QRectF(0,0,2,0.1));
wall2->translate(-1,0.7);
m_listWall->insert(wall2);
addItem(wall2);

KGLSpriteItem * wall3 = new KGLSpriteItem("sprites/bloc.png");
wall3->setRect(QRectF(0,0,0.1,2));
wall3->translate(-1,-1);
m_listWall->insert(wall3);
addItem(wall3);

KGLSpriteItem * wall4 = new KGLSpriteItem("sprites/bloc.png");
wall4->setRect(QRectF(0,0,0.1,2));
wall4->translate(0.9,-1);
m_listWall->insert(wall4);
addItem(wall4);



physicsEngine()->setItemTypeMovable(m_playerTank);
physicsEngine()->addCollisionRule(m_playerTank,m_listWall );
physicsEngine()->addCollisionRule(m_listBullet,m_listWall , KGLPhysicsImpl2::CenterInBox );


    KAction *up = m_collection->addAction("up");
    up->setShortcut(Qt::Key_Z);
    KAction *down = m_collection->addAction("down");
    down->setShortcut(Qt::Key_S);
    KAction *left = m_collection->addAction("left");
    left->setShortcut(Qt::Key_Q);
    KAction *right = m_collection->addAction("right");
    right->setShortcut(Qt::Key_D);

}
//======================================================
void KTankEngine::mainLoop()
{


m_playerTank->setSpeed(0);

m_playerTank->setMouse(m_mouse);

  if (gameKeyEvent()->keyPressed(m_collection->action("left")->shortcut()))
        m_playerTank->rotateLeft();

  if (gameKeyEvent()->keyPressed(m_collection->action("right")->shortcut()))
        m_playerTank->rotateRight();

 if (gameKeyEvent()->keyPressed(m_collection->action("up")->shortcut()))
        m_playerTank->moveUp();

 if (gameKeyEvent()->keyPressed(m_collection->action("down")->shortcut()))
        m_playerTank->moveDown();
KGLEngine2d::mainLoop();
}
//======================================================
void KTankEngine::mouseMoveEvent ( QMouseEvent * event ) 
{
m_mouse = mapToGL(event->pos());
}
//======================================================
void KTankEngine:: mousePressEvent ( QMouseEvent * event ) 
{


KBulletItem * bullet = new KBulletItem(m_playerTank);
physicsEngine()->setItemTypeMovable(bullet);
//bullet->scale(m_playerTank->scaleFactor());
m_listBullet->insert(bullet);
addItem(bullet);

//kDebug()<<m_listBullet->size();

}
//=========================================================
void KTankEngine::loadMap()
{

KGLSpriteItem * wall = new KGLSpriteItem("sprites/bloc.png");
wall->setRect(QRectF(0,0,1,0.2));
wall->translate(-0.4,-0.5);
m_listWall->insert(wall);
addItem(wall);

// physicsEngine()->addCollisionRule(ball, gpWall);








}