#include "ktitemselector.h"
/* This file is part of Ktank.
   Created by sacha schutz and olivier gueudelot

   KTank is free software; you can redistribute it and/or
   modify it under the terms of the GNU General Public
   License as published by the Free Software Foundation, version 2.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
   02110-1301, USA
*/

KTItemSelector::KTItemSelector(QWidget * parent) : QWidget (parent)
{

    treeView = new KFileTreeView;
    treeView->setRootUrl(KStandardDirs::locate("appdata", "blocks/"));


    thumbPix   = new QPixmap(164,164);
    thumbLabel = new QLabel;
    thumbPix->fill(Qt::red);
    thumbLabel->setPixmap(*thumbPix);
    thumbLabel->setMaximumSize (164,164);


    layout = new QVBoxLayout;
    layout->addWidget(thumbLabel);
    layout->addWidget(treeView);

    this->setLayout(layout);
    setupItemTree();

    connect( treeView, SIGNAL( clicked(QModelIndex)), this, SLOT(setThumbs()));

}



//====================================================
void KTItemSelector::setupItemTree()
{
    treeView->hideColumn (1);
    treeView->hideColumn (2);
    treeView->hideColumn (3);
    treeView->hideColumn (4);
    treeView->hideColumn (5);
}

//====================================================
void KTItemSelector::setThumbs()
{
    QString path = treeView->currentUrl().path();

    thumbPix = new QPixmap(path);
    thumbPix->scaled(164,164);
    thumbLabel->setPixmap(*thumbPix);
}


//====================================================
void KTItemSelector::setMode(int mode)
{
    qDebug()<<"ItemSelector change mode";
}


#include "ktitemselector.moc"

