/* -*- coding: utf-8 -*- */
/* This file is part of Ktank.
   Created by sacha schutz and olivier gueudelot

   KTank is free software; you can redistribute it and/or
   modify it under the terms of the GNU General Public
   License as published by the Free Software Foundation, version 2.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
   02110-1301, USA
*/
#ifndef KT_ITEMSELECTOR_H
#define KT_ITEMSELECTOR_H


#include <QWidget>
#include <QPainter>
#include <QPointF>
#include <QPixmap>
#include <QGraphicsPixmapItem>
#include <QKeyEvent>
#include <QSize>
#include <QMap>
#include <QString>
#include <QDebug>
#include <QStyleOption>
#include <QTreeWidget>
#include <QDirModel>
#include <QLabel>
#include <QVBoxLayout>


#include <ktreewidgetsearchline.h>
#include <kicon.h>
#include <kstandarddirs.h>
#include <kfiletreeview.h>

#include "ktconstants.h"


class KTItemSelector : public QWidget
{
Q_OBJECT
public:
    KTItemSelector(QWidget * parent = 0);

    void setupItemTree();
    KFileTreeView * getTree() {return treeView;}


public slots:
    void setThumbs();
    void setMode(int mode);


private:
    KFileTreeView * treeView;
    QVBoxLayout * layout;
    QString currentItem;
    QLabel  * thumbLabel;
    QPixmap * thumbPix;

};


#endif

