/* -*- coding: utf-8 -*- */

#include "ktmapheader.h"
#include <KLocale>

KTMapHeader::KTMapHeader( QWidget * parent) : QDialog( parent )
{
    createPresentationBox();
    createParamsBox();
    //void createTeamBox();

    buttonBox = new QDialogButtonBox(QDialogButtonBox::Ok | QDialogButtonBox::Cancel);

    QVBoxLayout * mainLayout = new QVBoxLayout;
    mainLayout->addWidget(presentationBox);
    mainLayout->addWidget(paramsBox);
    mainLayout->addWidget(buttonBox);
    //mainLayout->addWidget(paramsBox);
    setLayout(mainLayout);

    setWindowTitle(i18n("New Map"));

    connect(buttonBox, SIGNAL(accepted()), this, SLOT(accept()));
    connect(buttonBox, SIGNAL(rejected()), this, SLOT(reject()));



}



void KTMapHeader::createPresentationBox()
{
    presentationBox = new QGroupBox(i18n("Presentation : "));
    QGridLayout * layout = new QGridLayout ();

    
    lineEdits[0] = new QLineEdit("My custom map");
    labels   [0] = new QLabel   (i18n("Title : "));
    lineEdits[1] = new QLineEdit("");
    labels   [1] = new QLabel   (i18n("Description : "));
    lineEdits[2] = new QLineEdit("me");
    labels   [2] = new QLabel   (i18n("Author : "));

    layout->addWidget(labels   [0], 0, 0);
    layout->addWidget(lineEdits[0], 0, 1);
    layout->addWidget(labels   [1], 1, 0);
    layout->addWidget(lineEdits[1], 1, 1);
    layout->addWidget(labels   [2], 2, 0);
    layout->addWidget(lineEdits[2], 2, 1);

    presentationBox->setLayout(layout);
}


//====================================================
void KTMapHeader::createParamsBox()
{
    qDebug()<<"createParamsBox enter";
    paramsBox = new QGroupBox(i18n("Parameters : "));
    QGridLayout * layout = new QGridLayout ();

    spinBox[0] = new QSpinBox();
    spinBox[0]->setRange(10, 200);
    spinBox[0]->setValue(11);
    labels [3] = new QLabel   (i18n("Height : "));

    spinBox[1] = new QSpinBox();
    spinBox[1]->setRange(10, 200);
    spinBox[1]->setValue(11);
    labels [4] = new QLabel   (i18n("Width : "));

    // gameType

    spinBox[2] = new QSpinBox();
    spinBox[2]->setRange(1, 100);
    spinBox[2]->setValue(2);
    labels [6] = new QLabel   (i18n("Min player : "));

    spinBox[3] = new QSpinBox();
    spinBox[3]->setRange(1, 100);
    spinBox[3]->setValue(6);
    labels [7] = new QLabel   (i18n("Max player : "));

    spinBox[4] = new QSpinBox();
    spinBox[4]->setRange(1, 8);
    spinBox[4]->setValue(2);
    labels [8] = new QLabel   (i18n("Team Number : "));

    layout->addWidget(labels [3], 0, 0);   layout->addWidget(spinBox[0], 0, 1);
    layout->addWidget(labels [4], 1, 0);   layout->addWidget(spinBox[1], 1, 1);
    layout->addWidget(labels [6], 0, 2);   layout->addWidget(spinBox[2], 0, 3);
    layout->addWidget(labels [7], 1, 2);   layout->addWidget(spinBox[3], 1, 3);
    layout->addWidget(labels [8], 2, 2);   layout->addWidget(spinBox[4], 2, 3);

    paramsBox->setLayout(layout);
    qDebug()<<"createParamsBox leave";
}



//====================================================










#include "ktmapheader.moc"

