/* This file is part of Ktank.
   Created by sacha schutz and olivier gueudelot

   KTank is free software; you can redistribute it and/or
   modify it under the terms of the GNU General Public
   License as published by the Free Software Foundation, version 2.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
   02110-1301, USA
*/
#include <KApplication>
#include <KAboutData>
#include <KCmdLineArgs>

#include "ktmaineditor.h"
#include "ktmapfile.h"

int main (int argc, char *argv[])
{
    KAboutData aboutData( "ktankeditor","ktankeditor",
        ki18n("ktankeditor"), "1.0",
        ki18n("A map editor for ktank"),
        KAboutData::License_GPL,
        ki18n("Copyright (c) 2007 Developer") );
    KCmdLineArgs::init( argc, argv, &aboutData );

   


  KCmdLineOptions options; 
  options.add("+[file]", ki18n("Document to open")); 
  KCmdLineArgs::addCmdLineOptions(options);
 
KApplication app;

    KTMainEditor * editor = new KTMainEditor;
    editor->show();

editor->resize(editor->maximumSize ());

  KCmdLineArgs *args = KCmdLineArgs::parsedArgs();
  

if(args->count()) //new
  {
    editor->openMap(args->url(0).url()); //new
  }



    return app.exec();
}


