#include "ktankserver.h"


KTankServer::KTankServer(QWidget *parent ):QMainWindow(parent)
{

setupUi(this);

// Gestion du serveur
  serveur = new QTcpServer(this);

    if (!serveur->listen(QHostAddress::Any, 50885)) // Démarrage du serveur sur toutes les IP disponibles et sur le port 50585
    {
        // Si le serveur n'a pas été démarré correctement
        textEdit->append ("server dosn't start..."+ serveur->errorString());
    }
    else
    {
        // Si le serveur a été démarré correctement
   textEdit->append ("server start on port "+ QString::number(serveur->serverPort()));
   connect(serveur, SIGNAL(newConnection()), this, SLOT(newClient()));
    }


connect(buttonStart,SIGNAL(clicked()),this,SLOT(sendStartGame()));

}


//======================================================================================

void KTankServer::newClient()
{
   // envoyerATous("client connected");


    QTcpSocket *nouveauClient = serveur->nextPendingConnection();

  





    connect(nouveauClient, SIGNAL(readyRead()), this, SLOT(donneesRecues()));
    connect(nouveauClient, SIGNAL(disconnected()), this, SLOT(deconnexionClient()));
}


//======================================================================================
void KTankServer::donneesRecues()
{


QTcpSocket *socket = qobject_cast<QTcpSocket *>(sender());
if (socket == 0) // Si par hasard on n'a pas trouvé le client à l'origine du signal, on arrête la méthode
    return;






QDataStream in(socket);

quint32 type;

in >> type;




if ( type == 1) 
{

QString pseudo;
in>>pseudo;
if ( pseudo =="") 
pseudo="player"+QString::number(clients.size());
clients.insert(pseudo,socket);

KTANK tank;
listTank[pseudo]=tank;


textEdit->append(QString(pseudo)+" connected....");
refreshListPseudo();
}






if ( type == 2) 
{

qreal x,y;
in>>x;
in>>y;
textEdit->append(QString::number(x)+"-"+QString::number(y));
}



if ( type == 8) //Tank position
{
QString name;
qreal x; 
qreal y;
qreal at; 
qreal ah;

in>>name;
in>>x;
in>>y;
in>>at;
in>>ah;



listTank[name].x = x;
listTank[name].y = y;
listTank[name].at = at;
listTank[name].ah = ah;

sendTank(name);
textEdit->append("received tank from "+name);
}

// QString pseudo;
// in >> pseudo;
// 
// clients[pseudo] = socket;
// clients.remove("no_name");
// textEdit->append(pseudo+ " connected....");






}

//==========================================================================================
void KTankServer::sendTank(QString name)
{





QByteArray paquet;
    QDataStream out(&paquet, QIODevice::WriteOnly);

out << (quint32)9; 
 out<<name;
 out<<listTank[name].x;
 out<<listTank[name].y;
 out<<listTank[name].ah;
 out<<listTank[name].at;


   QMapIterator<QString, QTcpSocket*> i(clients);
         while (i.hasNext()) 
	  {	
           i.next();
	   i.value()->write(paquet);
	
	  }






}

//==========================================================================================
void KTankServer::deconnexionClient()
{
    //envoyerATous(tr("<em>Un client vient de se déconnecter</em>"));




    // On détermine quel client se déconnecte
    QTcpSocket *socket = qobject_cast<QTcpSocket *>(sender());
    if (socket == 0) // Si par hasard on n'a pas trouvé le client à l'origine du signal, on arrête la méthode
        return;



    QMapIterator<QString, QTcpSocket*> i(clients);
         while (i.hasNext()) {
             i.next();
             if ( i.value() == socket)
	    {
	    clients.remove(i.key());

	    listTank.remove(i.key());
	    textEdit->append(QString(i.key() +"disconnected"));

	    refreshListPseudo();
	    }

}




    

    socket->deleteLater();
}

void KTankServer::envoyerATous(const QString &message)
{
    // Préparation du paquet
//     QByteArray paquet;
//     QDataStream out(&paquet, QIODevice::WriteOnly);
// 
//     out << (quint16) 0; // On écrit 0 au début du paquet pour réserver la place pour écrire la taille
//     out << message; // On ajoute le message à la suite
//     out.device()->seek(0); // On se replace au début du paquet
//     out << (quint16) (paquet.size() - sizeof(quint16)); // On écrase le 0 qu'on avait réservé par la longueur du message
// 
// 
//     // Envoi du paquet préparé à tous les clients connectés au serveur
//     for (int i = 0; i < clients.size(); i++)
//     {
//         clients[i]->write(paquet);
//     }

}
//==========================================================
void KTankServer::sendStartGame()
{
QString pp;
  QByteArray paquet;
    QDataStream out(&paquet, QIODevice::WriteOnly);

    out << (quint32) 3; 
    out << clients.size();

foreach (const QString &player, players)
    out<<player;
	    


       QMapIterator<QString, QTcpSocket*> i(clients);
         while (i.hasNext()) 
	  {	
           i.next();
	   i.value()->write(paquet);
	
	  }




 textEdit->append("start games...");



}

//=======================================================
void KTankServer::sendPlayer()
{












}





//=========================================================
void KTankServer::refreshListPseudo()
{

listPseudo->clear();
players.clear();
 
   QMapIterator<QString, QTcpSocket*> i(clients);

         while (i.hasNext()) {
             i.next();
             listPseudo->addItem(QString(i.key()));
	     players<<i.key();
	    }
}















