//Magazynier, a warehouse assistant game.
//Copyright (C) 2008, 2009 Tadeusz Andrzej Kadlubowski yess@hell.org.pl
//
//This program is free software; you can redistribute it and/or modify
//it under the terms of the GNU General Public License as published by
//the Free Software Foundation; either version 2 of the License, or
//(at your option) any later version.
//
//This program is distributed in the hope that it will be useful,
//but WITHOUT ANY WARRANTY; without even the implied warranty of
//MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//GNU General Public License for more details.
//
//You should have received a copy of the GNU General Public License along
//with this program; if not, write to the Free Software Foundation, Inc.,
//51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.

#ifndef LEVELPACK_H
#define LEVELPACK_H

#include <QString>
#include <QObject>

class LevelModel;

class LevelPack : public QObject
{
	Q_OBJECT	
public:
	LevelPack(QString path);
	int getLevelCount();
	int getCurrentLevelNumber();
	int getSolvedLevelCount();
	QString getName();

	bool hasPrevLevels(void);
	bool hasNextAvailableLevels(void);
	
private:
	int m_levelCount;
	int m_firstUnsolved;
	int m_currentLevel;
	QString m_name;

public slots:
	void loadLevelByNumber(int n);
	void loadPrevLevel(void);
	void loadNextLevel(void);
	void reloadCurrentLevel(void);
	void loadFirstUnsolvedLevel(void);

	void markCurrentLevelAsSolved(void);
	//void markCurrentLevelAsLastPlayed(void); Do we need it?

	void thisLevelPackSelected(void);
signals:
	void levelLoaded(LevelModel *newLevelModel);
	void levelNotFound(void);
	void changeLevelPack(LevelPack *thisLevelPack);
};

#endif
