//Magazynier, a warehouse assistant game.
//Copyright (C) 2008, 2009 Tadeusz Andrzej Kadlubowski yess@hell.org.pl
//
//This program is free software; you can redistribute it and/or modify
//it under the terms of the GNU General Public License as published by
//the Free Software Foundation; either version 2 of the License, or
//(at your option) any later version.
//
//This program is distributed in the hope that it will be useful,
//but WITHOUT ANY WARRANTY; without even the implied warranty of
//MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//GNU General Public License for more details.
//
//You should have received a copy of the GNU General Public License along
//with this program; if not, write to the Free Software Foundation, Inc.,
//51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.

#ifndef RENDERER_H
#define RENDERER_H

#include <QObject>

class KGameRenderer;
class QPixmap;

class Renderer : public QObject
{
	Q_OBJECT

public:
	static Renderer *instance();
	void loadTheme();
	QPixmap getBackground();
	int getItemSize(void);
	void setLevelSize(int height, int width); //height x width items
	void setViewSize(int height, int width); //height x width pixels
	KGameRenderer* gameRenderer() const { return m_gameRenderer; }

protected:
	Renderer(QObject *parent);
private:
	static Renderer *m_instance;
	void setItemSize(void);
	int m_itemSize;
	int m_viewHeight, m_viewWidth, m_levelHeight, m_levelWidth;
	KGameRenderer *m_gameRenderer;

public slots:
	void sizeChanged();
};

#endif
