/***************************************************************************
 *   Copyright (C) 2008 Copyright 2008  Tom Vollerthun <vollerthun@gmx.de>
 *
 *   This program is free software; you can redistribute it and/or
 *   modify it under the terms of the GNU General Public
 *   License as published by the Free Software Foundation; either
 *   version 2 of the License, or (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
 ***************************************************************************/

#include "./config.h"

#include <KComponentData>
#include <KConfig>
#include <KConfigGroup>
#include <KGlobal>

#include <Qt>


const QString Config::CONFIG_GROUP_COLORS = "Colors";
const QString Config::CONFIG_GROUP_INTELLIGENCE = "Intelligence";
const QString Config::CONFIG_GROUP_SAVEGAME = "Savegame";

const QString Config::CONFIG_COLOR_BACKGROUND = "background";
const QColor Config::DEFAULT_COLOR_BACKGROUND = QColor(200, 200, 200);

const QString Config::CONFIG_COLOR_GRID = "gridcolor";
const QColor Config::DEFAULT_COLOR_GRID = Qt::darkGray;

const QString Config::CONFIG_COLOR_HIGHLIGHT_GRID = "highlight_gridcolor";
const QColor Config::DEFAULT_COLOR_HIGHLIGHT_GRID = Qt::red;


const QString Config::CONFIG_COLOR_BACKGROUND_GAMESELECT = "background_gameselect";
const QColor Config::DEFAULT_COLOR_BACKGROUND_GAMESELECT = QColor(250, 250, 200);

const QString Config::CONFIG_COLOR_BOX_OFFSTATE_DOT = "box_offstate_dotcolor";
const QColor Config::DEFAULT_COLOR_BOX_OFFSTATE_DOT = Qt::black;

const QString Config::CONFIG_COLOR_HINT_CROSSTHROUGH = "hint_crossthrough_color";
const QColor Config::DEFAULT_COLOR_HINT_CROSSTHROUGH = Qt::black;

const QString Config::CONFIG_AUTOSELECT_CLICK_COLOR = "autoselect_click_color";
const bool Config::DEFAULT_AUTOSELECT_CLICK_COLOR = false;

const QString Config::CONFIG_WAIT_BEFORE_AUTOSELECT_CLICK_COLOR = "wait_before_autoselect_click_color";
const int Config::DEFAULT_WAIT_BEFORE_AUTOSELECT_CLICK_COLOR = 2000;

const QString Config::CONFIG_LASTUSED_PACKAGE = "package_filename";
const QString Config::CONFIG_LASTUSED_GAME = "game_in_package";
