/***************************************************************************
 *   Copyright (C) 2008 Copyright 2008  Tom Vollerthun <vollerthun@gmx.de>
 *
 *   This program is free software; you can redistribute it and/or
 *   modify it under the terms of the GNU General Public
 *   License as published by the Free Software Foundation; either
 *   version 2 of the License, or (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
 ***************************************************************************/

#include "./colorconfig.h"
#include <qgridlayout.h>
#include <kcombobox.h>
#include <klocalizedstring.h>
#include <qlabel.h>
#include <kcolorbutton.h>
#include <ds/config.h>

#include <KComponentData>
#include <KConfig>
#include <KConfigGroup>
#include <KGlobal>

ColorConfig::ColorConfig() {

    QGridLayout *layout = new QGridLayout(this);

    int i = 0;
    addColorselection(layout, i18n("Grid:"), Config::CONFIG_COLOR_GRID, i++);
    addColorselection(layout, i18n("Background:"), Config::CONFIG_COLOR_BACKGROUND, i++);
    addColorselection(layout, i18n("Highlighted grid:"), Config::CONFIG_COLOR_HIGHLIGHT_GRID, i++);
    addColorselection(layout, i18n("Central dot in off-state Box:"), Config::CONFIG_COLOR_BOX_OFFSTATE_DOT, i++);
    addColorselection(layout, i18n("Cross on hint numbers:"), Config::CONFIG_COLOR_HINT_CROSSTHROUGH, i++);
}

void ColorConfig::addColorselection(QGridLayout * layout, QString name, QString configName, int row) {

    layout -> addWidget(new QLabel(name, this), row, 0);
    KColorButton *cob = new KColorButton(this);
    cob->setObjectName("kcfg_"+configName);
    layout -> addWidget(cob, row, 1);
}
