/***************************************************************************
 *   Copyright (C) 2008 Copyright 2008  Tom Vollerthun <vollerthun@gmx.de>
 *
 *   This program is free software; you can redistribute it and/or
 *   modify it under the terms of the GNU General Public
 *   License as published by the Free Software Foundation; either
 *   version 2 of the License, or (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
 ***************************************************************************/


#ifndef GAME_INFO_H_
#define GAME_INFO_H_

#include <QWidget>
#include <QLabel>
#include <QItemDelegate>

#include <QtGui/QWidget>

#include <threadweaver/Job.h>
#include <threadweaver/ThreadWeaver.h>

#include <KComboBox>
#ifndef KXMLGUIWINDOW_H
    #include <kxmlguiwindow.h>
#endif

#include "ds/data.h"
#include "ds/package.h"

class GameInfo : public QWidget {
Q_OBJECT

public:
	GameInfo(KXmlGuiWindow *parent);
	~GameInfo() {}

public slots:
    void readPackages();
	void setPackage(Package * package);
	void setPackage(int i);
    void nextPackage();
    void previousPackage();
	void nextGame();
	void previousGame();
	void game(int i);
    void readConfig();
    void jobFinished(ThreadWeaver::Job* job);
    void addPackage(Package * package);
    void setupActions(KXmlGuiWindow *parent);
    void setupConnectionsAndLayout();

signals:
	void changedGameTo(Data * data);

private:
	int m_currentGame;
	KComboBox * m_gameSelector;
	KComboBox * m_packageSelector;
	Package * m_package;
    QString m_lastPackage;
    int m_lastGameInPackage;

};

class LoaderJob : public ThreadWeaver::Job {
    Q_OBJECT
    public:
        LoaderJob (QString filename, Package * package, QObject* parent=0);
        void doRun();
        Package * package() const;
    protected:
        void run ();
    private:
        QString const m_filename;
        Package * const m_package;
};


#endif /*GAME_INFO_H_*/
