/***************************************************************************
 *   Copyright (C) 2008 Copyright 2008  Tom Vollerthun <vollerthun@gmx.de>
 *
 *   This program is free software; you can redistribute it and/or
 *   modify it under the terms of the GNU General Public
 *   License as published by the Free Software Foundation; either
 *   version 2 of the License, or (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
 ***************************************************************************/

#ifndef XBM_FORMAT_H
#define XBM_FORMAT_H

#include <QString>
#include <QImage>

#include "nonogram_io.h"
#include "ds/data.h"

/**
* This class reads XBM-Files and converts them into a form, the nonogram-program can use
*/

class XbmFormat : public NonogramIo
{
    public:

    	Data * readFile(const QString & fileName);

    	Data * readData(const QByteArray & data );

    private:
    	Data * image2Data(const QImage & image);
};

#endif

