/***************************************************************************
 *   Copyright (C) 2008 Copyright 2008  Tom Vollerthun <vollerthun@gmx.de>
 *
 *   This program is free software; you can redistribute it and/or
 *   modify it under the terms of the GNU General Public
 *   License as published by the Free Software Foundation; either
 *   version 2 of the License, or (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
 ***************************************************************************/


#ifndef MAINWINDOW_H
#define MAINWINDOW_H

#include <QStringList>

#include <KXmlGuiWindow>

#include "ds/solver.h"
#include "gui/grid.h"
#include "gui/game_info.h"

class MainWindow : public KXmlGuiWindow
{

  Q_OBJECT

  public:
    MainWindow(QWidget *parent=0);
	void openGame(const QString &inputFileName);

signals:
    void settingsChanged();

  private:
    Grid *grid;
    virtual void setupActions();
    GameInfo * info;

  private slots:
    void newGame();
    void load();
    void configureSettings();

};

#endif
