/* loggerwidget.cpp

    Parsek - free client for playing 4X space strategy games
    Copyright (C) 2006-2007  Jure Repinc <jlp@holodeck1.com>

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

*/

#include "loggerwidget.h"
#include <QString>
#include <cstdarg>
#include <QScrollBar>

LoggerWidget::LoggerWidget(QWidget *parent)
            : QWidget(parent)
{
    setupUi(this);
    loggermodel = new QStringListModel();
    loggerview->setModel(loggermodel);
    //connect(clearButton,SIGNAL(clicked()),this,SLOT(clear()));
}
LoggerWidget::~LoggerWidget()
{
}
void LoggerWidget::error(const char* mesg, ...)
{
    QString message;
    va_list ap;
    va_start(ap, mesg);
    message.vsprintf(mesg, ap);
    va_end(ap);
    QString fullmessage = "EE: " + message;
    QStringList list;
    list << fullmessage;
    loggermodel->setStringList(loggermodel->stringList() + list);

    QScrollBar *bar = loggerview->verticalScrollBar();
    bar->setValue(bar->maximum());
}

void LoggerWidget::warning(const char* mesg, ...)
{
    QString message;
    va_list ap;
    va_start(ap, mesg);
    message.vsprintf(mesg, ap);
    va_end(ap);
    QString fullmessage = "WW: " + message;
    QStringList list;
    list << fullmessage;
    loggermodel->setStringList(loggermodel->stringList() + list);

    QScrollBar *bar = loggerview->verticalScrollBar();
    bar->setValue(bar->maximum());
}

void LoggerWidget::info(const char* mesg, ...)
{
    QString message;
    va_list ap;
    va_start(ap, mesg);
    message.vsprintf(mesg, ap);
    va_end(ap);
    QString fullmessage = "II: " + message;
    QStringList list;
    list << fullmessage;
    loggermodel->setStringList(loggermodel->stringList() + list);
    QScrollBar *bar = loggerview->verticalScrollBar();
    bar->setValue(bar->maximum());
}

void LoggerWidget::debug(const char* mesg, ...)
{
    QString message;
    va_list ap;
    va_start(ap, mesg);
    message.vsprintf(mesg, ap);
    va_end(ap);
    QString fullmessage = "DD: " + message;
    QStringList list;
    list << fullmessage;
    loggermodel->setStringList(loggermodel->stringList() + list);
    QScrollBar *bar = loggerview->verticalScrollBar();
    bar->setValue(bar->maximum());
}
void LoggerWidget::parsek(const char* mesg, ...)
{
    QString message;
    va_list ap;
    va_start(ap, mesg);
    message.vsprintf(mesg, ap);
    va_end(ap);
    QString fullmessage = "PARSEK: " + message;
    QStringList list;
    list << fullmessage;
    loggermodel->setStringList(loggermodel->stringList() + list);
    QScrollBar *bar = loggerview->verticalScrollBar();
    bar->setValue(bar->maximum());
}
void LoggerWidget::clear()
{
    QStringList list;
    loggermodel->setStringList(list);
}
