#include "objectview.h"
#include "ui_objectview.h"

ObjectView::ObjectView(QWidget *parent) :
    QWidget(parent),
    m_ui(new Ui::ObjectView)
{
    m_ui->setupUi(this);
    objectmodel = new ObjectModel();
    connect(m_ui->ObjectUniverseTree, SIGNAL(clicked(QModelIndex)),this, SLOT(displayinfo(QModelIndex)));
}

ObjectView::~ObjectView()
{
    delete m_ui;
}

void ObjectView::changeEvent(QEvent *e)
{
    QWidget::changeEvent(e);
    switch (e->type()) {
    case QEvent::LanguageChange:
        m_ui->retranslateUi(this);
        break;
    default:
        break;
    }
}

void ObjectView::displayinfo(const QModelIndex &index)
{
    if (!index.isValid())
    {
        return;
    }

   ObjectItem *selecteditem = static_cast<ObjectItem *>(index.internalPointer());
   QString text;
   m_ui->ObjectInfoID->setText("ID:  " + text.setNum(selecteditem->id()) );
   m_ui->ObjectInfoLCD->display(text);
   m_ui->ObjectInfoName->setText("Name:  " + selecteditem->name());
   m_ui->ObjectInfoType->setText(selecteditem->typestring());
   m_ui->ObjectInfoLastmodified->setText("Last modified time:  " + text.setNum(selecteditem->modTime()) );
}
void ObjectView::setGame(TPProto::GameLayer *game)
{
    objectmodel->setGame(game);
    objectmodel->getUniverse();
    m_ui->ObjectUniverseTree->setModel(objectmodel);
}
void ObjectView::clear()
{
   ObjectModel *dummy = new ObjectModel();
   m_ui->ObjectUniverseTree->setModel(dummy);

   m_ui->ObjectInfoID->setText("ID:  ");
   m_ui->ObjectInfoLCD->display(0);
   m_ui->ObjectInfoName->setText("Name:  ");
   m_ui->ObjectInfoType->setText("Type");
   m_ui->ObjectInfoLastmodified->setText("Last modified time:  ");
}
