#ifndef OBJECTVIEW_H
#define OBJECTVIEW_H

#include <QtGui/QWidget>
#include <QAbstractItemModel>
#include <QDataWidgetMapper>

#include <tpproto/gamelayer.h>
#include "objectitem.h"
#include "objectmodel.h"

using namespace TPProto;

namespace Ui {
    class ObjectView;
}

class ObjectView : public QWidget {
    Q_OBJECT
public:
    ObjectView(QWidget *parent = 0);
    ~ObjectView();
    void setGame(TPProto::GameLayer *game);
    void clear();
public Q_SLOTS:
    void displayinfo(const QModelIndex &index);
protected:
    void changeEvent(QEvent *e);
private:
    Ui::ObjectView *m_ui;
    ObjectModel *objectmodel;
};
#endif // OBJECTVIEW_H
