#ifndef PARSEKSTATUSLISTENER_H
#define PARSEKSTATUSLISTENER_H

#include <string>
#include <QObject>
#include <tpproto/gamestatuslistener.h>

class ParsekStatusListener : public QObject, public TPProto::GameStatusListener
{
Q_OBJECT

public:
ParsekStatusListener();
virtual ~ParsekStatusListener();
virtual void connected();
virtual void disconnected();
virtual bool redirected(const std::string& url);
virtual void accountCreated(bool);
virtual void loggedIn(bool);
virtual void eotStarted();
virtual void eotEnded();
virtual void timeToEot(uint32_t);

Q_SIGNALS:
void signalConnected();
void signalDisconnected();
void signalAccountCreated(bool);
void signalLoggedIn(bool);
void signalEotStarted();
void signalEotEnded();
void signalTimeToEot(uint32_t timetoeot);
};

#endif // PARSEKSTATUSLISTENER_H
