/*
    Copyright 2008 Gábor Lehel <illissius@gmail.com>

    This file is part of Superpong.

    Superpong is free software: you can redistribute it and/or modify
    it under the terms of the GNU Lesser General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    Superpong is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public License
    along with Superpong (files COPYING and COPYING.LESSER).
    If not, see <http://www.gnu.org/licenses/>.
*/

#ifndef PONG_SCENE_H
#define PONG_SCENE_H

#include <QGraphicsScene>

class PongScene: public QGraphicsScene
{
    Q_OBJECT
    typedef QGraphicsScene super;

    public:
    static PongScene *instance();
    virtual ~PongScene();

    public slots:
    void newGame();
    void goal( int who );

    protected:
    virtual void keyPressEvent( QKeyEvent *e );
    virtual void keyReleaseEvent( QKeyEvent *e );
    virtual void focusInEvent( QFocusEvent *e );
    virtual void focusOutEvent( QFocusEvent *e );
    virtual void timerEvent( QTimerEvent *e );

    private:
    static PongScene* s_instance;
    PongScene();
    void start();
    void animate();
    void showScore();
    void showMessage( QString s );
    void hideMessage();
    void pause( bool whether );

    class Private;
    Private* const d;
};

#endif
